# encoding: UTF-8
module TIG
  module ReAssign0
    ###
    def self.check()
      return true if Sketchup.active_model.selection.grep(Sketchup::ComponentInstance)[0] || Sketchup.active_model.selection.grep(Sketchup::Group)[0]
      return false
    end#check
    def self.do()
      m=Sketchup.active_model
      s=m.selection
      is=s.grep(Sketchup::ComponentInstance)
      gs=s.grep(Sketchup::Group)
      cs=is+gs
      m.start_operation("ReAssign0", true)
        cs.each{|c| self.process(c) }
      m.commit_operation
    end#do
    def self.process(cc=nil)
      return unless cc
      cc.definition.entities.each{|e| e.layer=nil }
      is=cc.definition.entities.grep(Sketchup::ComponentInstance)
      gs=cc.definition.entities.grep(Sketchup::Group)
      cs=is+gs
      cs.each{|c| self.process(c) }
    end#process
    #menu
    unless @loaded
      UI.add_context_menu_handler{|menu|
        menu.add_item("ReAssign0..."){ self.do() } if self.check()
      }
      @loaded=true
    end
    ###
  end#module
end#module
